Summary: D-BUS message bus
Name:    dbus
Epoch:   1
Version: 1.14.8
Release: 2%{?dist}

# The effective license of the majority of the package, including the shared
# library, is "GPL-2+ or AFL-2.1". Certain utilities are "GPL-2+" only.
License: (GPLv2+ or AFL) and GPLv2+
URL:     http://www.freedesktop.org/Software/dbus/
Source0: https://dbus.freedesktop.org/releases/%{name}/%{name}-%{version}.tar.xz
Source1: 00-start-message-bus.sh
Source2: dbus-run-installed-tests
Patch3000: 0001-tools-Use-Python3-for-GetAllMatchRules.patch
Patch5000: 5000-mute-autolaunch-testcase.patch

BuildRequires: audit-libs-devel >= 0.9, libX11-devel, libcap-ng-devel
BuildRequires: pkgconfig(libselinux) >= 2.0.86
BuildRequires: pkgconfig(libsystemd), pkgconfig(systemd)
BuildRequires: pkgconfig(expat), xmlto
BuildRequires: pkgconfig(gio-2.0) >= 2.40.0, python3-dbus, python3-gobject
BuildRequires: cmake, libtool, autoconf-archive
BuildRequires: /usr/bin/Xvfb
Requires: dbus-broker >= 16-4

%description
D-Bus is a message bus system, a simple way for applications to talk to one another.
it makes it simple and reliable to code a "single instance" application or daemon,
and to launch applications and daemons on demand when their services are needed.

%package common
Summary:        D-BUS message bus configuration
BuildArch:      noarch

%description common
The dbus-common package provides the configuration and setup files for D-Bus
implementations to provide a System and User Message Bus.

%package daemon
Summary:        D-BUS message bus
Requires:       libselinux >= 2.0.86
Requires:       dbus-common = %{epoch}:%{version}-%{release}
Requires:       dbus-libs = %{epoch}:%{version}-%{release}
Requires:       dbus-tools = %{epoch}:%{version}-%{release}
Requires(pre):  /usr/sbin/useradd

%description daemon
DBus-daemon is an application that uses D-Bus library to implement a message bus daemon.


%package tools
Summary:        D-BUS Tools and Utilities
Requires:       dbus-libs = %{epoch}:%{version}-%{release}

%description tools
This package provides tools and utilities to interact with D-Bus Message Bus.

%package libs
Summary: Libraries for accessing D-BUS

%description libs
This package provides libraries for accessing D-BUS.

%package doc
Summary: Developer documentation for D-BUS
Requires: %{name}-daemon = %{epoch}:%{version}-%{release}
BuildArch: noarch

%description doc
This package provides man pages and some other documents for D-Bus.

%package devel
Summary: Development files for D-BUS
Requires: dbus-libs = %{epoch}:%{version}-%{release}
Requires: xml-common

%description devel
This package provides libraries and header files for D-BUS developer.

%package tests
Summary: Tests for the %{name}-daemon package
Requires: %{name}-daemon = %{epoch}:%{version}-%{release}

%description tests
This package provides some ready-made tests to check the running condition
of D-Bus.

%package x11
Summary: X11-requiring add-ons for D-BUS
Requires: %{name}-daemon = %{epoch}:%{version}-%{release}

%description x11
This package provides Xlib which is needed by D-Bus.

%prep
%autosetup -p1


%build
env NOCONFIGURE=1 ./autogen.sh

%global _configure ../configure
mkdir build
pushd build
%global config_opts --enable-libaudit --enable-selinux %--with-system-socket=/run/dbus/system_bus_socket --with-dbus-user=dbus %--libexecdir=/%{_libexecdir}/dbus-1 --runstatedir=/run --enable-user-session --enable-installed-tests
%configure %{config_opts} --disable-asserts
%make_build
popd

mkdir build-check
pushd build-check
%configure %{config_opts}  --enable-asserts --enable-verbose-mode --enable-tests
%make_build
popd

%install
pushd build
%make_install
popd


find %{buildroot} -name '*.a' -type f -delete
find %{buildroot} -name '*.la' -type f -delete

# replace units in target.wants with wantsby
rm -f %{buildroot}%{_unitdir}/sockets.target.wants/dbus.socket
rm -f %{buildroot}%{_unitdir}/multi-user.target.wants/dbus.service
rm -f %{buildroot}%{_userunitdir}/sockets.target.wants/dbus.socket

echo -e "\n[Install]\nWantedBy=sockets.target" >> %{buildroot}%{_unitdir}/dbus.socket
echo -e "\n[Install]\nWantedBy=sockets.target" >> %{buildroot}%{_userunitdir}/dbus.socket
echo -e "\n[Install]\nAlias=dbus.service messagebus.service\nWantedBy=multi-user.target" >> %{buildroot}%{_unitdir}/dbus.service
echo -e "\n[Install]\nAlias=dbus.service" >> %{buildroot}%{_userunitdir}/dbus.service

# rename the dbus.service because it already exits in dbus-broker
mv %{buildroot}%{_userunitdir}/dbus.service %{buildroot}%{_userunitdir}/dbus-daemon.service
mv %{buildroot}%{_unitdir}/dbus.service %{buildroot}%{_unitdir}/dbus-daemon.service

install -Dp -m755 %{SOURCE1} %{buildroot}%{_sysconfdir}/X11/xinit/xinitrc.d/00-start-message-bus.sh
install -Dp -m755 %{SOURCE2} %{buildroot}%{_libexecdir}/dbus-1/
install --directory %{buildroot}%{_sysconfdir}/dbus-1/session.d
install --directory %{buildroot}%{_sysconfdir}/dbus-1/system.d
install --directory %{buildroot}%{_datadir}/dbus-1/interfaces
install --directory %{buildroot}/var/lib/dbus
install --directory %{buildroot}/run/dbus

%check
pushd build-check
env DBUS_TEST_SLOW=1 make check || (cat test/name-test/test-suite.log && exit 1)
popd



%pre daemon
%global uid 81
/usr/sbin/groupadd -r -g %{uid} dbus 2>/dev/null || :
/usr/sbin/useradd -c 'System message bus' -u %{uid} -g %{uid} \
    -s /sbin/nologin -r -d '/' dbus 2> /dev/null || :

%post common
%systemd_post dbus.socket
%systemd_user_post dbus.socket

%post daemon
%systemd_post dbus-daemon.service
%systemd_user_post dbus-daemon.service

%preun common
%systemd_preun dbus.socket
%systemd_user_preun dbus.socket

%preun daemon
%systemd_preun dbus-daemon.service
%systemd_user_preun dbus-daemon.service

%postun common
%systemd_postun dbus.socket
%systemd_user_postun dbus.socket

%postun daemon
%systemd_postun dbus-daemon.service
%systemd_user_postun dbus-daemon.service


%files
# The 'dbus' package is only retained for compatibility purposes.

%files common
%dir %{_sysconfdir}/dbus-1
%dir %{_sysconfdir}/dbus-1/session.d
%dir %{_sysconfdir}/dbus-1/system.d
%config %{_sysconfdir}/dbus-1/session.conf
%config %{_sysconfdir}/dbus-1/system.conf
%dir %{_datadir}/dbus-1
%dir %{_datadir}/dbus-1/session.d
%dir %{_datadir}/dbus-1/system.d
%{_datadir}/dbus-1/session.conf
%{_datadir}/dbus-1/system.conf
%{_datadir}/dbus-1/services
%{_datadir}/dbus-1/system-services
%{_datadir}/dbus-1/interfaces
%{_sysusersdir}/dbus.conf
%{_unitdir}/dbus.socket
%{_userunitdir}/dbus.socket

%files daemon
%license COPYING
%doc AUTHORS CONTRIBUTING.md NEWS README
%ghost %dir /run/%{name}
%dir %{_localstatedir}/lib/dbus/
%dir %{_libexecdir}/dbus-1
%attr(4750,root,dbus) %{_libexecdir}/dbus-1/dbus-daemon-launch-helper
%exclude %{_libexecdir}/dbus-1/dbus-run-installed-tests
%{_tmpfilesdir}/dbus.conf
%{_unitdir}/dbus-daemon.service
%{_userunitdir}/dbus-daemon.service
%{_bindir}/dbus-daemon
%{_bindir}/dbus-cleanup-sockets
%{_bindir}/dbus-run-session
%{_bindir}/dbus-test-tool
%{_mandir}/man1/dbus-cleanup-sockets.1*
%{_mandir}/man1/dbus-daemon.1*
%{_mandir}/man1/dbus-run-session.1*
%{_mandir}/man1/dbus-test-tool.1*

%files tools
%license COPYING
%{_bindir}/dbus-send
%{_bindir}/dbus-monitor
%{_bindir}/dbus-update-activation-environment
%{_bindir}/dbus-uuidgen
%{_mandir}/man1/dbus-monitor.1*
%{_mandir}/man1/dbus-send.1*
%{_mandir}/man1/dbus-update-activation-environment.1*
%{_mandir}/man1/dbus-uuidgen.1*

%files libs
%license COPYING
%{_libdir}/*dbus-1*.so.*

%files doc
%{_pkgdocdir}/*

%files devel
%{_datadir}/xml/dbus-1
%{_libdir}/lib*.so
%dir %{_libdir}/dbus-1.0
%{_libdir}/cmake/DBus1
%{_libdir}/dbus-1.0/include/
%{_libdir}/pkgconfig/dbus-1.pc
%{_includedir}/*

%files tests
%{_libexecdir}/dbus-1/installed-tests
%{_libexecdir}/dbus-1/dbus-run-installed-tests
%{_datadir}/installed-tests

%files x11
%{_bindir}/dbus-launch
%{_mandir}/man1/dbus-launch.1*
%{_sysconfdir}/X11/xinit/xinitrc.d/00-start-message-bus.sh


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1:1.14.8-2
- Rebuilt for loongarch release

* Mon Jan 15 2024 Upgrade Robot <upbot@opencloudos.org> - 1.14.8-1
- Upgrade to version 1.14.8

* Mon May 9 2022 cunshunxia <cunshunxia@tencent.com> - 1.14.0-4
- revert to 1.14.0

* Thu Jul 27 2023 kianli <kianli@tencent.com> - 1.15.6-1
- Upgrade to 1.15.6

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14.0-2
- Rebuilt for OpenCloudOS Stream 23

* Mon May 9 2022 cunshunxia <cunshunxia@tencent.com> - 1.14.0-1
- initial build
